(function (Raphael) {
    Raphael.channelAlpha = function (x, y, size, initcolor, element) {
        return new ChannelAlpha(x, y, size, initcolor, element);
    };
    var doc = document, win = window,
        ChannelAlpha = function (x, y, size, initcolor, element) {
            size = size || 200;
            var w3 = 3 * size / 200,
                w1 = size / 200,
                fi = 1.6180339887,
                size20 = size / 20,
                size2 = size / 2,
                padding = 2 * size / 200,
                height = size + size20 * 2 + padding * 3,
                t = this,
                opacity = 1.0,
                r = element ? Raphael(element, size, height) : Raphael(x, y, size, height);
            w1 < 1 && (w1 = 1);
            w3 < 1 && (w3 = 1);

            // brightness drawing
            var h = size20 * 2 + 2;
            t.brect = r.rect(padding + h / fi / 2, padding * 2, size - padding * 2 - h / fi, h - padding * 2).attr({
                stroke: "#fff",
                fill: "180-#fff-#000"
            });
            t.cursorb = r.set();
            t.cursorb.push(r.rect(size - padding - h / fi, padding, ~~(h / fi), h, w3).attr({
                stroke: "#000",
                opacity: .5,
                "stroke-width": w3
            }));
            t.cursorb.push(t.cursorb[0].clone().attr({
                stroke: "#fff",
                opacity: 1,
                "stroke-width": w1
            }));
            t.btop = t.brect.clone().attr({
                stroke: "#000",
                fill: "#000",
                opacity: 0
            });
            var style = t.btop.node.style;
            style.unselectable = "on";
            style.MozUserSelect =  "none";
            style.WebkitUserSelect= "none";
        
            t.bwidth = ~~(h / fi) / 2;
            t.minx = padding + t.bwidth;
            t.maxx = size - h / fi - padding + t.bwidth;

            t.opacity = opacity;
            t.padding = padding;
            t.raphael = r;
            t.size2 = size2;
            t.size20 = size20;
            t.x = x;
            t.y = y;

            t.btop.drag(function (dx, dy, x, y) {
                t.docOnMove(dx, dy, x, y);
            }, function (x, y) {
                t.bOnTheMove = true;
                t.setOpacity(x - t.x);
            }, function () {
                t.bOnTheMove = false;
            });

            t.value(initcolor || "0.5");
            this.onchanged && this.onchanged(this.value());
        };
    ChannelAlpha.prototype.setOpacity = function (x) {
        x < this.minx && (x = this.minx);
        x > this.maxx && (x = this.maxx);
        this.cursorb.attr({x: x - this.bwidth});
        this.opacity = (x - this.minx) / (this.maxx - this.minx);
        this.onchange && this.onchange(this.value());
    };
    ChannelAlpha.prototype.docOnMove = function (dx, dy, x, y) {
        if (this.bOnTheMove) {
            this.setOpacity(x - this.x);
        }
    };
    ChannelAlpha.prototype.remove = function () {
        this.raphael.remove();
        this.color = function () {
            return false;
        };
    };
    ChannelAlpha.prototype.value = function (opacity) {
        if (opacity!==undefined) {
            this.opacity = parseFloat(opacity);

            this.cursorb.attr({x: this.opacity * (this.maxx - this.minx) + this.minx - this.bwidth});
            return this;
        } else {
            return this.opacity;
        }
    };
})(window.Raphael);
