var dectohex = function (d, padding) {
	var hex = Number(d).toString(16);
	padding = typeof (padding) === "undefined" || padding === null ? padding = 2 : padding;

	while (hex.length < padding) {
		hex = "0" + hex;
	}

	return hex;
};


(function (Raphael) {
    Raphael.theme = function (x, y, size, element) {
        return new Theme(x, y, size, element);
    };
    var Theme = function (x, y, size, element) {

            size = size || 600;
            var t = this,
                txt_layer = document.getElementById("txt_layer"),
                txt_field = document.getElementById("txt_field"),
				txt_selected = document.getElementById("h1"),
 				current = null,
                paper = element ? Raphael(element, size, size) : Raphael(x, y, size, size);

            var img = paper.image('bd.jpg', 30, 20, 540, 420);

			// import vector graphics
            t.gfxItems = graphics(paper);
			// merge theme colors
            t.txtItems = t.parseData(txt_field.value);

            for (var g in t.gfxItems) {
				// add round corners to rect
				if(t.gfxItems[g].type == 'rect') {
					t.gfxItems[g].attr({r:5});
				}
//				else {
//				}

				if(t.gfxItems[g].attr('target') != "layer1")
					t.gfxItems[g].hide();

                (function (st, g, opacity) {
					var opacity = st.data('fill-opacity');
                    st[0].style.cursor = "pointer";
                    st[0].onclick = function () {
                        t.current = g.replace(/[0-9\-]*$/g, "");
						txt_selected.innerHTML = t.current;
						var clr = st.attr('fill');
						var opacity = st.attr('fill-opacity');
				        t.OnSelectItem && t.OnSelectItem(clr,opacity);
                    };
                    st[0].onmouseover = function () {
                        st.animate({stroke: "#ccc"}, 500);
                    };

                    st[0].onmouseout = function () {
                        st.animate({stroke: "none"}, 500);
                    };
                })(t.gfxItems[g], g);
            }



            var butt_txt = paper.set(),
				textLayer = new Array("layer1", "layer2", "layer3", "layer4", "layer5"),
				textName = new Array("Menu", "Event", "Channel", "Replay", "Other"),
				buttLayer = new Array(5);

            for (var i = 0; i < buttLayer.length; ++i) {
				buttLayer[i] = paper.set();
			    buttLayer[i].push(paper.rect(0.5, 0.5, 100, 30, 10).attr({stroke: "#ccc", fill: "#fff", "fill-opacity": .4, "stroke-width": 2}),
			               		paper.text(50,15,textName[i]).attr({font: '18px Helvetica, Arial', stroke: "none", fill: "#000"}),
			               		paper.rect(0.5, 0.5, 100, 30, 10).attr({fill: "#fff", opacity: 0}));
				buttLayer[i].translate(30 + (i*110), 530);

		        var click = function (layer) {
		            return function () {
						txt_layer.style.display = 'none';
						img.show();
						for (var g in t.gfxItems) {
							if(t.gfxItems[g].attr('target') == layer)
								t.gfxItems[g].show();
							else
								t.gfxItems[g].hide();
						}
					};
		        };
		        var mouseover = function (butt) {
		            return function () {
				        butt[1].animate({fill: "#fc0"}, 300);
					};
		        };
		        var mouseout = function (butt) {
		            return function () {
			        	butt[1].stop().attr({fill: "#000"});
					};
		        };
				buttLayer[i][2].click(click(textLayer[i]));
				buttLayer[i][2].mouseover(mouseover(buttLayer[i]));
				buttLayer[i][2].mouseout(mouseout(buttLayer[i]));
			};

            butt_txt.push(paper.rect(0.5, 0.5, 100, 30, 10).attr({stroke: "#ccc", fill: "#fff", "fill-opacity": .4, "stroke-width": 2}),
                       paper.text(50,15,"Parse").attr({font: '18px Helvetica, Arial', stroke: "none", fill: "#000"}),
                       paper.rect(0.5, 0.5, 100, 30, 10).attr({fill: "#fff", opacity: 0}));

            butt_txt.translate(30, 480);
            butt_txt[2].click(function () {
					if(txt_layer.style.display == 'inline') {
						var txtItems = t.parseData(txt_field.value);
						if(txtItems) {
							t.txtItems = txtItems;
							txt_layer.style.display = 'none';
							img.show();
							for (var g in t.gfxItems) {
								if(t.gfxItems[g].attr('target') == "layer1")
									t.gfxItems[g].show();
								else
									t.gfxItems[g].hide();
							}
						} else {
							alert("None matching data found!");
						}
					} else {
						txt_field.value = t.buildData();
						img.hide();
						for (var g in t.gfxItems) {
							t.gfxItems[g].hide();
						}
						txt_layer.style.display = 'inline';
					}
            }).mouseover(function () {
                butt_txt[1].animate({fill: "#fc0"}, 300);
            }).mouseout(function () {
                butt_txt[1].stop().attr({fill: "#000"});
            });

        },
        proto = Theme.prototype;

    proto.remove = function () {
        this.raphael.remove();
        this.color = function () {
            return false;
        };
    };

    proto.value = function (color, opacity) {
        if (color && this.current) {
            var hex = Raphael.color(color).hex;
		    for (var g in this.gfxItems) {
				var t = g.replace(/[0-9\-]*$/g, "");
				if(t === this.current) {
					this.gfxItems[g].attr({fill: hex, 'fill-opacity': opacity});
				}
			}

//			if(this.current) {
//				this.current.attr({fill: hex, 'fill-opacity': opacity});
//			}
        }
    };

	proto.parseINIString = 	function (data){
		var regex = {
			section: /^\s*\[\s*([^\]]*)\s*\]\s*$/,
			param: /^\s*([\w\.\-\_]+)\s*=\s*(.*?)\s*$/,
			comment: /^\s*;.*$/
		};
		var value = {};
		var lines = data.split(/\r\n|\r|\n/);
		var section = null;

		for(x=0;x<lines.length;x++)
		{
			var line = lines[x];
			if(regex.comment.test(line)){
				return;
			}else if(regex.param.test(line)){
				var match = line.match(regex.param);
				if(section){
				    value[section][match[1]] = match[2];
				}else{
				    value[match[1]] = match[2];
				}
			}else if(regex.section.test(line)){
				var match = line.match(regex.section);
				value[match[1]] = {};
				section = match[1];
			}else if(line.length == 0 && section){
				section = null;
			};
		}
		return value;
	};

	proto.parseValue = function (data,field) {
		if(data.length == 8
			&& data.match(/^[0-9a-f]{8}$/i)) {
			var opa = data.substr(0, 2);
			var rgb = data.substr(2, 6);
			var opacity = parseFloat(parseInt(opa,16))/255.0;
			field.attr({fill: '#'+rgb, 'fill-opacity': opacity});
			return true;
		}
		return false;
	};

	proto.parseData = function (data){
		var bFound = false;
		var data = this.parseINIString(data);
        for (var g in this.gfxItems) {
			var t = g.replace(/[0-9\-]*$/g, "");
			if(data[t] 
				&& typeof(data[t]) == "string") {
				bFound |= this.parseValue(data[t], this.gfxItems[g]);
				}
			}
		if(bFound)
			return data;
		else
			return undefined;
	};

	proto.buildValue = function (fill,opacity){
		    var rgb = Raphael.color(fill);
        	return dectohex(parseInt(255 * opacity)) + dectohex(rgb.r) + dectohex(rgb.g) + dectohex(rgb.b);
	}

	proto.buildData = function (data){
        for (var g in this.gfxItems) {
			var fill = this.gfxItems[g].attr('fill');
			var opacity = this.gfxItems[g].attr('fill-opacity');
			var t = g.replace(/[0-9\-]*$/g, "");
        	this.txtItems[t] = this.buildValue(fill,opacity);
		}
		var ini = "";
        for (var d in this.txtItems) {
			ini += d + " = " + this.txtItems[d] + "\n";
		}
		return ini;
	};

	proto.handleFileSelect = function(evt) {
		var files = evt.target.files; // FileList object

		// Loop through the FileList and render text to textarea.
		for (var i = 0, f; f = files[i]; i++) {

			// Only process theme files.
			if (!f.type.match('application/x-theme')) {
				continue;
			}

			var reader = new FileReader();

			// Closure to capture the file information.
			reader.onload = (function(theFile) {
				return function(e) {
					document.getElementById("txt_field").value = e.target.result;
				};
			})(f);

			// Read in the image file as a text.
			reader.readAsText(f);
		}
	}


})(window.Raphael);
