// Quick Howto - Convert SVG to graphics
// 1.) upload SVG into http://readysetraphael.com/
// 2.) paste text with RaphaelJS elements into this file
// 3.) remove object Paper - var Raphael('rsr', '800', '600');
// 4.) remove layer objects var layer ... 
// 5.) merge all graphic variables into one object gfx => var clrBackground -> gfx.clrBackground
//     replace attribut layer with target => parent: 'layer1' -> target: 'layer1'
// sed -e 's/;\nclr.*\.attr/.attr/g'
// sed -e 's/var clr/gfx.clr/g'
// sed -e 's/parent/target/g'

var graphics = function (rsr) {

// Object with all vector graphic elements
var gfx = {};

gfx.clrBackground = rsr.rect(51.428574, 27.505043, 500, 400).attr({id: 'clrBackground',x: '51.428574',y: '27.505043',rx: '10',ry: '10',target: 'layer1',fill: '#111100',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrBackground');
gfx.clrButtonRedBg = rsr.rect(51.428574, 394.505, 125, 32).attr({id: 'clrButtonRedBg',x: '51.428574',y: '394.505',rx: '12.5',ry: '10',target: 'layer1',fill: '#cc2222',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrButtonRedBg');
gfx.clrButtonRedFg = rsr.text(113.85826, 416.46204, 'Red').attr({id: 'clrButtonRedFg',target: 'layer1',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"text-anchor": 'middle',fill: '#ffffff',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrButtonRedFg');
gfx.clrButtonGreenBg = rsr.rect(176.42856, 394.505, 125, 32).attr({id: 'clrButtonGreenBg',x: '176.42856',y: '394.505',rx: '12.5',ry: '10',target: 'layer1',fill: '#229922',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrButtonGreenBg');
gfx.clrButtonGreenFg = rsr.text(239.12192, 416.3136, 'Green').attr({id: 'clrButtonGreenFg',target: 'layer1',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"text-anchor": 'middle',fill: '#ffffff',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrButtonGreenFg');
gfx.clrButtonYellowBg = rsr.rect(301.42859, 394.505, 125, 32).attr({id: 'clrButtonYellowBg',x: '301.42859',y: '394.505',rx: '12.5',ry: '10',target: 'layer1',fill: '#ccbb22',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrButtonYellowBg');
gfx.clrButtonYellowFg = rsr.text(364.01648, 416.46204, 'Yellow').attr({id: 'clrButtonYellowFg',target: 'layer1',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"text-anchor": 'middle',fill: '#000000',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrButtonYellowFg');
gfx.clrButtonBlueBg = rsr.rect(426.42859, 394.505, 125, 32).attr({id: 'clrButtonBlueBg',x: '426.42859',y: '394.505',rx: '12.5',ry: '10',target: 'layer1',fill: '#0000cc',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrButtonBlueBg');
gfx.clrButtonBlueFg = rsr.text(488.55359, 416.46204, 'Blue').attr({id: 'clrButtonBlueFg',target: 'layer1',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"text-anchor": 'middle',fill: '#ffffff',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrButtonBlueFg');
gfx.clrMenuTitleBg = rsr.rect(51.428574, 28.21936, 500, 32).attr({id: 'clrMenuTitleBg',x: '51.428574',y: '28.21936',rx: '10',ry: '10',target: 'layer1',fill: '#0000c0',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrMenuTitleBg');
gfx.clrMenuTitleFg = rsr.text(115.44029, 50.195923, 'Title').attr({id: 'clrMenuTitleFg',target: 'layer1',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"text-anchor": 'middle',fill: '#eeeeee',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrMenuTitleFg');
gfx.clrMenuItemSelectable = rsr.text(153.86607, 102.104, '1 Menuitem').attr({id: 'clrMenuItemSelectable',target: 'layer1',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"text-anchor": 'middle',fill: '#eeeeee',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrMenuItemSelectable');
gfx.clrMenuItemCurrentBg = rsr.rect(51.428574, 111.36218, 484, 32).attr({id: 'clrMenuItemCurrentBg',x: '51.428574',y: '111.36218',rx: '10',ry: '10',target: 'layer1',fill: '#6d93db',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrMenuItemCurrentBg');
gfx.clrMenuItemCurrentFg = rsr.text(155.77623, 133.17859, '2 Menuitem').attr({id: 'clrMenuItemCurrentFg',target: 'layer1',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"text-anchor": 'middle',fill: '#000000',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrMenuItemCurrentFg');
gfx.clrMenuText = rsr.text(143.94029, 352.14108, 'MenuText').attr({id: 'clrMenuText',target: 'layer1',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#eeeeee',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial',"-inkscape-font-specification": 'Arial'}).data('id', 'clrMenuText');
gfx.clrMenuScrollbarTotal = rsr.rect(535.42859, 62.029846, 16, 332.65671).attr({id: 'clrMenuScrollbarTotal',x: '535.42859',y: '62.029846',rx: '5',ry: '5',target: 'layer1',fill: '#4d4d4d',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrMenuScrollbarTotal');
gfx.clrMenuScrollbarShown = rsr.rect(538.42859, 83.402878, 10, 166.32835).attr({id: 'clrMenuScrollbarShown',x: '538.42859',y: '83.402878',rx: '5',ry: '5',target: 'layer1',fill: '#1a1a1a',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrMenuScrollbarShown');

gfx.clrBackground2 = rsr.rect(51.428574, 27.505039, 500, 400).attr({id: 'clrBackground-2',x: '51.428574',y: '27.505039',rx: '10',ry: '10',target: 'layer2',fill: '#000000',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrBackground9');
gfx.clrButtonRedBg2 = rsr.rect(51.428574, 394.505, 125, 32).attr({id: 'clrButtonRedBg-2',x: '51.428574',y: '394.505',rx: '12.5',ry: '10',target: 'layer2',fill: '#cc2222',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrButtonRedBg2');
gfx.clrButtonRedFg2 = rsr.text(113.85826, 416.46204, 'Red').attr({id: 'clrButtonRedFg-2',target: 'layer2',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"text-anchor": 'middle',fill: '#ffffff',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrButtonRedFg2');
gfx.clrButtonGreenBg2 = rsr.rect(176.42856, 394.505, 125, 32).attr({id: 'clrButtonGreenBg-2',x: '176.42856',y: '394.505',rx: '12.5',ry: '10',target: 'layer2',fill: '#229922',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrButtonGreenBg2');
gfx.clrButtonGreenFg2 = rsr.text(239.12192, 416.3136, 'Green').attr({id: 'clrButtonGreenFg-2',target: 'layer2',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"text-anchor": 'middle',fill: '#ffffff',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrButtonGreenFg2');
gfx.clrButtonYellowBg2 = rsr.rect(301.42859, 394.505, 125, 32).attr({id: 'clrButtonYellowBg-2',x: '301.42859',y: '394.505',rx: '12.5',ry: '10',target: 'layer2',fill: '#ccbb22',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrButtonYellowBg2');
gfx.clrButtonYellowFg2 = rsr.text(364.01648, 416.46204, 'Yellow').attr({id: 'clrButtonYellowFg-2',target: 'layer2',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"text-anchor": 'middle',fill: '#000000',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrButtonYellowFg2');
gfx.clrButtonBlueBg2 = rsr.rect(426.42859, 394.505, 125, 32).attr({id: 'clrButtonBlueBg-2',x: '426.42859',y: '394.505',rx: '12.5',ry: '10',target: 'layer2',fill: '#0000cc',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrButtonBlueBg2');
gfx.clrButtonBlueFg2 = rsr.text(488.55359, 416.46204, 'Blue').attr({id: 'clrButtonBlueFg-2',target: 'layer2',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"text-anchor": 'middle',fill: '#ffffff',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrButtonBlueFg2');
gfx.clrMenuTitleBg2 = rsr.rect(51.428574, 28.219357, 500, 32).attr({id: 'clrMenuTitleBg-2',x: '51.428574',y: '28.219357',rx: '10',ry: '10',target: 'layer2',fill: '#0000c0',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrMenuTitleBg2');
gfx.clrMenuTitleFg2 = rsr.text(131.8125, 50.195919, 'Title').attr({id: 'clrMenuTitleFg-2',target: 'layer2',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"text-anchor": 'middle',fill: '#eeeeee',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrMenuTitleFg2');
gfx.clrMenuEventShortText = rsr.text(189.58594, 209.56668, 'EventShortText').attr({id: 'clrMenuEventShortText',target: 'layer2',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#ffff00',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial',"-inkscape-font-specification": 'Arial'}).data('id', 'clrMenuEventShortText');
gfx.clrMenuEventDescription = rsr.text(168.30469, 293.2532, 'Event\nDescription').attr({id: 'clrMenuEventDescription',target: 'layer2',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#00ffff',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial',"-inkscape-font-specification": 'Arial'}).data('id', 'clrMenuEventDescription');
gfx.clrMenuEventTitle = rsr.text(161.20312, 166.42566, 'EventTitle').attr({id: 'clrMenuEventTitle',target: 'layer2',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#ffff00',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial',"-inkscape-font-specification": 'Arial'}).data('id', 'clrMenuEventTitle');
gfx.clrMenuEventTime = rsr.text(165.23438, 124.86712, 'EventTime').attr({id: 'clrMenuEventTime',target: 'layer2',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#eeeeee',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial',"-inkscape-font-specification": 'Arial'}).data('id', 'clrMenuEventTime');
gfx.clrMenuEventSymbolBg = rsr.rect(51.492538, 63.149246, 200, 32).attr({id: 'clrMenuEventSymbolBg',x: '51.492538',y: '63.149246',rx: '9.6576576',ry: '9.5288897',target: 'layer2',fill: '#4d4d4d',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrMenuEventSymbolBg');
gfx.clrMenuEventSymbolFg = rsr.text(136.08594, 83.618225, 'Symbol').attr({id: 'clrMenuEventSymbolFg',target: 'layer2',"font-size": '16px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#ffff00',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrMenuEventSymbolFg');
gfx.clrMenuScrollbarTotal2 = rsr.rect(535.19031, 61.47015, 16, 332.65671).attr({id: 'clrMenuScrollbarTotal-2',x: '535.19031',y: '61.47015',rx: '5',ry: '5',target: 'layer2',fill: '#4d4d4d',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrMenuScrollbarTotal2');
gfx.clrMenuScrollbarShown2 = rsr.rect(538.19031, 82.843178, 10, 166.32835).attr({id: 'clrMenuScrollbarShown-2',x: '538.19031',y: '82.843178',rx: '5',ry: '5',target: 'layer2',fill: '#1a1a1a',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrMenuScrollbarShown2');

gfx.clrBackground3 = rsr.rect(52.611942, 298.52982, 500, 128.26866).attr({id: 'clrBackground-3',x: '52.611942',y: '298.52982',rx: '10',ry: '10',target: 'layer3',fill: '#111100',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrBackground1');
gfx.clrChannelNumberDateBg = rsr.rect(52.611942, 298.52982, 300, 32).attr({id: 'clrChannelNumberDateBg',x: '52.611942',y: '298.52982',rx: '10',ry: '10',target: 'layer3',fill: '#000080',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrChannelNumberDateBg');
gfx.clrChannelEpgTimeBg = rsr.rect(52.611942, 362.79846, 64, 64).attr({id: 'clrChannelEpgTimeBg',x: '52.611942',y: '362.79846',rx: '10',ry: '10',target: 'layer3',fill: '#000080',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrChannelEpgTimeBg');
gfx.clrChannelNumberDateFg = rsr.text(201.86194, 323.11966, 'ChannelNumber').attr({id: 'clrChannelNumberDateFg',target: 'layer3',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#ffffff',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrChannelNumberDateFg');
gfx.clrChannelNameBg = rsr.rect(52.611942, 330.66412, 402.61194, 32).attr({id: 'clrChannelNameBg',x: '52.611942',y: '330.66412',rx: '10',ry: '10',target: 'layer3',fill: '#00ffff',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrChannelNameBg');
gfx.clrChannelNameFg = rsr.text(253.82416, 355.25397, 'ChannelName').attr({id: 'clrChannelNameFg',target: 'layer3',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#ffffff',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrChannelNameFg');
gfx.clrChannelTimeBarBg = rsr.rect(116.41791, 363.35818, 16, 64).attr({id: 'clrChannelTimeBarBg',x: '116.41791',y: '363.35818',rx: '6.3525925',ry: '7.425108',target: 'layer3',fill: '#4d4d4d',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrChannelTimeBarBg');
gfx.clrChannelTimeBarFg = rsr.rect(119.05224, 367.47015, 10, 32).attr({id: 'clrChannelTimeBarFg',x: '119.05224',y: '367.47015',rx: '3.9703703',ry: '3.7125542',target: 'layer3',fill: '#1a1a1a',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrChannelTimeBarFg');
gfx.clrChannelEpgTimeFg = rsr.text(84.834595, 403.24768, 'Time').attr({id: 'clrChannelEpgTimeFg',target: 'layer3',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#ffffff',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrChannelEpgTimeFg');
gfx.clrChannelEpgTitle = rsr.text(199.94135, 386.13461, 'Title').attr({id: 'clrChannelEpgTitle',target: 'layer3',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#ffee00',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrChannelEpgTitle');
gfx.clrChannelEpgShortText = rsr.text(227.80853, 411.18054, 'ShortText').attr({id: 'clrChannelEpgShortText',target: 'layer3',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#ffffff',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrChannelEpgShortText');
gfx.clrChannelEpgDuration = rsr.text(470.93161, 387.6731, 'Duration').attr({id: 'clrChannelEpgDuration',target: 'layer3',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#333333',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrChannelEpgDuration');
gfx.clrChannelSymbolRecord = rsr.text(417.36292, 319.11255, 'Rec').attr({id: 'clrChannelSymbolRecord',target: 'layer3',"font-size": '16px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#ff0000',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrChannelSymbolRecord');
gfx.clrChannelSymbolActive = rsr.text(461.86771, 319.30786, 'Symbol').attr({id: 'clrChannelSymbolActive',target: 'layer3',"font-size": '16px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#ffff00',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrChannelSymbolActive');
gfx.clrChannelSymbolInactive = rsr.text(517.8725, 319.30786, 'Symbol').attr({id: 'clrChannelSymbolInactive',target: 'layer3',"font-size": '16px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#333333',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrChannelSymbolInactive');

gfx.clrBackground4 = rsr.rect(52.611942, 298.52982, 500, 128.26866).attr({id: 'clrBackground-4',x: '52.611942',y: '298.52982',rx: '10',ry: '10',target: 'layer4',fill: '#111100',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrBackground2');
gfx.clrReplayTitleBg = rsr.rect(52.611942, 298.52982, 300, 32).attr({id: 'clrReplayTitleBg',x: '52.611942',y: '298.52982',rx: '10',ry: '10',target: 'layer4',fill: '#000080',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrReplayTitleBg');
gfx.clrReplayTitleFg = rsr.text(83.973221, 323.11966, 'Title').attr({id: 'clrReplayTitleFg',target: 'layer4',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#ffffff',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrReplayTitleFg');
gfx.clrReplayProgressRest = rsr.rect(52.611942, 330.66412, 500, 32).attr({id: 'clrReplayProgressRest',x: '52.611942',y: '330.66412',rx: '12.418906',ry: '10',target: 'layer4',fill: '#ffffff',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrReplayProgressRest');
gfx.clrReplayModeJump = rsr.text(104.32869, 407.22287, 'Jump to').attr({id: 'clrReplayModeJump',target: 'layer4',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#ffffff',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrReplayModeJump');
gfx.clrReplayCurrent = rsr.text(422.79727, 321.62833, 'Current').attr({id: 'clrReplayCurrent',target: 'layer4',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#333333',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrReplayCurrent');
gfx.clrReplaySymbolActive = rsr.text(448.43488, 409.14178, 'Symbol').attr({id: 'clrReplaySymbolActive',target: 'layer4',"font-size": '16px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#ffff00',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrReplaySymbolActive');
gfx.clrReplaySymbolInactive = rsr.text(504.43967, 409.14178, 'Symbol').attr({id: 'clrReplaySymbolInactive',target: 'layer4',"font-size": '16px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#333333',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrReplaySymbolInactive');
gfx.clrReplayTotal = rsr.text(501.9585, 322.44174, '/ Total').attr({id: 'clrReplayTotal',target: 'layer4',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"writing-mode": 'lr-tb',"text-anchor": 'middle',fill: '#333333',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrReplayTotal');
gfx.clrReplayProgressSeen = rsr.rect(51.492538, 330.70801, 200, 32).attr({id: 'clrReplayProgressSeen',x: '51.492538',y: '330.70801',rx: '6.6666665',ry: '10',target: 'layer4',fill: '#0000ff',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrReplayProgressSeen');
gfx.clrReplayProgressSelected = rsr.rect(202.61194, 338.66412, 200, 16).attr({id: 'clrReplayProgressSelected',x: '202.61194',y: '338.66412',rx: '6.6666665',ry: '5',target: 'layer4',fill: '#ff0000',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrReplayProgressSelected');
gfx.clrReplayProgressMark = rsr.path("m 400.51794,330.48148 5,0 0,24.11724 7.12384,8.03908 -18.95085,0.0989 6.82701,-8.13802 z").attr({id: 'clrReplayProgressMark',target: 'layer4',fill: '#000000',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrReplayProgressMark');
gfx.clrReplayProgressCurrent = rsr.rect(443.78622, 338.66412, 100, 16).attr({id: 'clrReplayProgressCurrent',x: '443.78622',y: '338.66412',rx: '5',ry: '5',target: 'layer4',fill: '#ff0000',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrReplayProgressCurrent');

gfx.clrVolumeBarUpper = rsr.rect(52.569378, 356.6958, 500, 20).attr({id: 'clrVolumeBarUpper',x: '52.569378',y: '356.6958',rx: '10',ry: '10',target: 'layer5',fill: '#111100',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrVolumeBarUpper');
gfx.clrVolumePromptBg = rsr.rect(52.611942, 324.52982, 200, 32).attr({id: 'clrVolumePromptBg',x: '52.611942',y: '324.52982',rx: '5',ry: '5',target: 'layer5',fill: '#111100',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrVolumePromptBg');
gfx.clrVolumePromptFg = rsr.text(153.06311, 348.97903, 'Volume').attr({id: 'clrVolumePromptFg',target: 'layer5',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"text-anchor": 'middle',fill: '#ffee00',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrVolumePromptFg');
gfx.clrVolumeBarLower = rsr.rect(54.850746, 358.6958, 400, 16).attr({id: 'clrVolumeBarLower',x: '54.850746',y: '358.6958',rx: '10',ry: '10',target: 'layer5',fill: '#000080',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrVolumeBarLower');
gfx.clrVolumeBarMute = rsr.rect(54.850739, 358.60446, 50, 16).attr({id: 'clrVolumeBarMute',x: '54.850739',y: '358.60446',rx: '10',ry: '10',target: 'layer5',fill: '#ff2200',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrVolumeBarMute');
gfx.clrMessageInfoBg = rsr.rect(51.492538, 77.148323, 500, 50).attr({id: 'clrMessageInfoBg',x: '51.492538',y: '77.148323',rx: '10',ry: '10',target: 'layer5',fill: '#111100',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrMessageInfoBg');
gfx.clrMessageWarningBg = rsr.rect(51.492538, 127.9962, 500, 50).attr({id: 'clrMessageWarningBg',x: '51.492538',y: '127.9962',rx: '10',ry: '10',target: 'layer5',fill: '#111100',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrMessageWarningBg');
gfx.clrMessageErrorBg = rsr.rect(51.492538, 178.44327, 500, 50).attr({id: 'clrMessageErrorBg',x: '51.492538',y: '178.44327',rx: '10',ry: '10',target: 'layer5',fill: '#111100',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrMessageErrorBg');
gfx.clrMessageStatusBg = rsr.rect(51.492538, 26.86566, 500, 50).attr({id: 'clrMessageStatusBg',x: '51.492538',y: '26.86566',rx: '10',ry: '10',target: 'layer5',fill: '#111100',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1'}).data('id', 'clrMessageStatusBg');
gfx.clrMessageWarningFg = rsr.text(190.29762, 159.06067, 'MessageWarning').attr({id: 'clrMessageWarningFg',target: 'layer5',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"text-anchor": 'middle',fill: '#ffee00',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrMessageWarningFg');
gfx.clrMessageErrorFg = rsr.text(172.7195, 209.50772, 'MessageError').attr({id: 'clrMessageErrorFg',target: 'layer5',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"text-anchor": 'middle',fill: '#ff2200',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrMessageErrorFg');
gfx.clrMessageInfoFg = rsr.text(166.01637, 108.35925, 'MessageInfo').attr({id: 'clrMessageInfoFg',target: 'layer5',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"text-anchor": 'middle',fill: '#ffee00',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrMessageInfoFg');
gfx.clrMessageStatusFg = rsr.text(180.032, 58.076599, 'MessageStatus').attr({id: 'clrMessageStatusFg',target: 'layer5',"font-size": '24px',"font-style": 'normal',"font-variant": 'normal',"font-weight": 'normal',"font-stretch": 'normal',"text-align": 'center',"line-height": '100%',"letter-spacing": '0px',"word-spacing": '0px',"text-anchor": 'middle',fill: '#ffee00',"fill-opacity": '1',stroke: 'none','stroke-width':'1','stroke-opacity':'1',"font-family": 'Arial'}).data('id', 'clrMessageStatusFg');

return gfx;
};
